using ICSSoft.Common;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ICSSoft.Entity;
using UFSoft.UBF.Util.Context;
using System.ServiceModel;
using www.ufida.org.EntityData;
using UFSoft.UBF.Exceptions1;
using ICS.WCF.Base;

namespace ICSSoft.APICloseCompRpt
{
    public class CloseCompRpt
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string connString = System.Configuration.ConfigurationManager.AppSettings["ERPConnStr"];
        private static string ERPDB = System.Configuration.ConfigurationManager.AppSettings["ERPDB"];
        /// <summary>
        /// 关闭完工报告（外部通过API调用）
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public bool Close(List<ICSManufactureReceiveDoc> infos)
        {
            bool ResultFlag = false;
            object context;
            string OrgID = "";
            UFIDAU9ISVMOIRcvCompleteRpt4ExternalSrvClient client = new UFIDAU9ISVMOIRcvCompleteRpt4ExternalSrvClient();
            UFIDAU9ISVMOCompRptKeyDTOData[] _result = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
            MessageBase[] returnMsg;
            try
            {
                if (infos == null || infos.Count == 0)
                {
                    throw new Exception("传入数据不能为空!");
                }
                string orgsql = @"select ID from Base_Organization
                                          where Code='{0}'";
                orgsql = string.Format(orgsql, infos[0].WorkPoint);
                DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                if (orgdt.Rows.Count != 0)
                {
                    OrgID = orgdt.Rows[0]["ID"].ToString();
                }
                else
                {
                    throw new Exception("传入组织编码错误!");
                }

                UFIDAU9ISVMOCompRptKeyDTOData[] compRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                List<UFIDAU9ISVMOCompRptKeyDTOData> compRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();

                foreach (ICSManufactureReceiveDoc Info in infos)
                {
                    UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                    model.m_docNo = Info.MRCVCode;
                    model.m_iD = GetTypeID(Info.MRCVCode, OrgID);
                    model.m_operateResult = true;
                    model.m_operateType = true;
                    compRptKeyList.Add(model);
                }

                compRptKeyDTOs = compRptKeyList.ToArray();

                context = CreateContextObj(OrgID);

                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                _result = client.Do(out returnMsg, context, compRptKeyDTOs, true);
                bool ISSuccess = true;
                foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                {
                    if (info.m_operateResult == false)
                    {
                        ISSuccess = false;
                    }
                }
                if (ISSuccess == true)
                {
                    ResultFlag = true;
                }
                else
                {
                    #region 存在完工报告关闭失败时先取消入库已入库的完工报告
                    UFIDAU9ISVMOCompRptKeyDTOData[] opencompRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                    List<UFIDAU9ISVMOCompRptKeyDTOData> opencompRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();
                    foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                    {
                        if (info.m_operateResult == true)
                        {
                            UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                            model.m_docNo = info.m_docNo;
                            model.m_iD = GetTypeID(info.m_docNo, OrgID);
                            model.m_operateResult = true;
                            model.m_operateType = false;//true:完工报告入库 false:完工报告取消入库
                            opencompRptKeyList.Add(model);
                        }
                    }
                    opencompRptKeyDTOs = opencompRptKeyList.ToArray();
                    client.Do(out returnMsg, context, opencompRptKeyDTOs, true);
                    #endregion
                }
            }
            catch (Exception ex)
            {
                #region 存在完工报告关闭失败时先取消入库已入库的完工报告
                context = CreateContextObj(OrgID);
                UFIDAU9ISVMOCompRptKeyDTOData[] opencompRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                List<UFIDAU9ISVMOCompRptKeyDTOData> opencompRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();
                foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                {
                    if (info.m_operateResult == true)
                    {
                        UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                        model.m_docNo = info.m_docNo;
                        model.m_iD = GetTypeID(info.m_docNo, OrgID);
                        model.m_operateResult = true;
                        model.m_operateType = false;//true:完工报告入库 false:完工报告取消入库
                        opencompRptKeyList.Add(model);
                    }
                }
                opencompRptKeyDTOs = opencompRptKeyList.ToArray();
                client.Do(out returnMsg, context, opencompRptKeyDTOs, true);
                #endregion
                log.Error(ex.Message);
                throw new Exception(ex.Message);
            }
            return ResultFlag;
        }
        /// <summary>
        /// 关闭完工报告（接口内部调用，如：创建退料单后调用审核单据）
        /// </summary>
        /// <param name="DocNOList"></param>
        /// <param name="OrgCode"></param>
        /// <returns></returns>
        public bool Close(List<string> DocNOList, string OrgCode)
        {
            bool ResultFlag = false;
            object context;
            string OrgID = "";
            UFIDAU9ISVMOIRcvCompleteRpt4ExternalSrvClient client = new UFIDAU9ISVMOIRcvCompleteRpt4ExternalSrvClient();
            UFIDAU9ISVMOCompRptKeyDTOData[] _result = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
            MessageBase[] returnMsg;
            try
            {
                if (DocNOList == null || DocNOList.Count == 0)
                {
                    throw new Exception("传入数据不能为空!");
                }
                string orgsql = @"select ID from Base_Organization
                                          where Code='{0}'";
                orgsql = string.Format(orgsql, OrgCode);
                DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                if (orgdt.Rows.Count != 0)
                {
                    OrgID = orgdt.Rows[0]["ID"].ToString();
                }
                else
                {
                    throw new Exception("入库传入组织编码错误!");
                }

                UFIDAU9ISVMOCompRptKeyDTOData[] compRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                List<UFIDAU9ISVMOCompRptKeyDTOData> compRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();

                foreach (string DocNO in DocNOList)
                {
                    UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                    model.m_docNo = DocNO;
                    model.m_iD = GetTypeID(DocNO, OrgID);
                    model.m_operateResult = true;
                    model.m_operateType = true;
                    compRptKeyList.Add(model);
                }

                compRptKeyDTOs = compRptKeyList.ToArray();

                context = CreateContextObj(OrgID);

                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                _result = client.Do(out returnMsg, context, compRptKeyDTOs, true);
                bool ISSuccess = true;
                foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                {
                    if (info.m_operateResult == false)
                    {
                        ISSuccess = false;
                    }
                }
                if (ISSuccess == true)
                {
                    ResultFlag = true;
                }
                else
                {
                    #region 存在完工报告关闭失败时先取消入库已入库的完工报告
                    UFIDAU9ISVMOCompRptKeyDTOData[] opencompRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                    List<UFIDAU9ISVMOCompRptKeyDTOData> opencompRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();
                    foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                    {
                        if (info.m_operateResult == true)
                        {
                            UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                            model.m_docNo = info.m_docNo;
                            model.m_iD = GetTypeID(info.m_docNo, OrgID);
                            model.m_operateResult = true;
                            model.m_operateType = false;//true:完工报告入库 false:完工报告取消入库
                            opencompRptKeyList.Add(model);
                        }
                    }
                    opencompRptKeyDTOs = opencompRptKeyList.ToArray();
                    client.Do(out returnMsg, context, opencompRptKeyDTOs, true);
                    #endregion
                }
            }
            catch (Exception ex)
            {
                #region 存在完工报告关闭失败时先取消入库已入库的完工报告
                context = CreateContextObj(OrgID);
                UFIDAU9ISVMOCompRptKeyDTOData[] opencompRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                List<UFIDAU9ISVMOCompRptKeyDTOData> opencompRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();
                foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                {
                    if (info.m_operateResult == true)
                    {
                        UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                        model.m_docNo = info.m_docNo;
                        model.m_iD = GetTypeID(info.m_docNo, OrgID);
                        model.m_operateResult = true;
                        model.m_operateType = false;//true:完工报告入库 false:完工报告取消入库
                        opencompRptKeyList.Add(model);
                    }
                }
                opencompRptKeyDTOs = opencompRptKeyList.ToArray();
                client.Do(out returnMsg, context, opencompRptKeyDTOs, true);
                #endregion
                log.Error(ex.Message);
                throw new Exception(ex.Message);
            }
            return ResultFlag;
        }
        /// <summary>
        /// 打开完工报告（接口内部调用）
        /// </summary>
        /// <param name="DocNOList"></param>
        /// <param name="OrgCode"></param>
        /// <returns></returns>
        public bool OpenCompRpt(List<string> DocNOList, string OrgCode)
        {
            bool ResultFlag = false;
            object context;
            string OrgID = "";
            UFIDAU9ISVMOIRcvCompleteRpt4ExternalSrvClient client = new UFIDAU9ISVMOIRcvCompleteRpt4ExternalSrvClient();
            UFIDAU9ISVMOCompRptKeyDTOData[] _result = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
            MessageBase[] returnMsg;
            try
            {
                if (DocNOList == null || DocNOList.Count == 0)
                {
                    throw new Exception("传入数据不能为空!");
                }
                string orgsql = @"select ID from Base_Organization
                                          where Code='{0}'";
                orgsql = string.Format(orgsql, OrgCode);
                DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                if (orgdt.Rows.Count != 0)
                {
                    OrgID = orgdt.Rows[0]["ID"].ToString();
                }
                else
                {
                    throw new Exception("入库传入组织编码错误!");
                }

                UFIDAU9ISVMOCompRptKeyDTOData[] compRptKeyDTOs = new UFIDAU9ISVMOCompRptKeyDTOData[] { };
                List<UFIDAU9ISVMOCompRptKeyDTOData> compRptKeyList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();

                foreach (string DocNO in DocNOList)
                {
                    UFIDAU9ISVMOCompRptKeyDTOData model = new UFIDAU9ISVMOCompRptKeyDTOData();
                    model.m_docNo = DocNO;
                    model.m_iD = GetTypeID(DocNO, OrgID);
                    model.m_operateResult = true;
                    model.m_operateType = false;//true:完工报告入库 false:完工报告取消入库
                    compRptKeyList.Add(model);
                }

                compRptKeyDTOs = compRptKeyList.ToArray();

                context = CreateContextObj(OrgID);

                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                _result = client.Do(out returnMsg, context, compRptKeyDTOs, true);
                bool ISSuccess = true;
                foreach (UFIDAU9ISVMOCompRptKeyDTOData info in _result)
                {
                    if (info.m_operateResult == false)
                    {
                        throw new Exception(info.m_errorMsg);
                    }
                }
            }
            catch (Exception ex)
            {
                log.Error(ex.Message);
                throw new Exception(ex.Message);
            }
            return ResultFlag;
        }

        private static long GetTypeID(string docTypeCode, string OrgID)
        {
            string sql = @"select ID from MO_CompleteRpt where DocNo='" + docTypeCode + "' AND Org='" + OrgID + "' ";
            DataTable dt = DBhlper.Query(sql, Appconfig.GetU9ConnStr());
            if (dt.Rows.Count > 0)
            {
                return long.Parse(dt.Rows[0][0].ToString());
            }
            else
            {
                return 0;
            }
        }

        #region 给上下文信息赋值
        /// <summary>
        /// 给上下文信息赋值
        /// </summary>
        /// <returns></returns>
        private static ThreadContext CreateContextObj(string OrgID)
        {
            // 实例化应用上下文对象
            ThreadContext thContext = new ThreadContext();


            System.Collections.Generic.Dictionary<object, object> ns = new Dictionary<object, object>();
            ns.Add("OrgID", OrgID);
            ns.Add("UserID", ConfigurationManager.AppSettings["userID"].ToString());
            ns.Add("UserCode", ConfigurationManager.AppSettings["userCode"].ToString());
            ns.Add("Datetime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            ns.Add("CultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("EnterpriseID", ConfigurationManager.AppSettings["enterpriseID"].ToString());
            ns.Add("DefaultCultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            thContext.nameValueHas = ns;

            return thContext;
        }
        #endregion
    }
}
